package io.zipcoder;

import java.util.concurrent.locks.ReadWriteLock;
import java.util.concurrent.locks.ReentrantReadWriteLock;

/**
 * Make this extend the Copier like `UnsafeCopier`, except use locks to make sure that the actual intro gets printed
 * correctly every time.  Make the run method thread safe.
 */
public class SafeCopier extends Copier {

    ReadWriteLock alohomora;

    public SafeCopier(String toCopy) {
        super(toCopy);
        alohomora = new ReentrantReadWriteLock();
    }

    public void run() {
        alohomora.writeLock().lock();
        alohomora.readLock().lock();
        try {
            while (stringIterator.hasNext()) {
                copied += stringIterator.next() + " ";
            }
            copied = copied.trim();
        } finally {
            alohomora.writeLock().unlock();
            alohomora.readLock().unlock();
        }
    }

}
